/*
 * toglimg.h
 *
 * Copyright (C) 2001, Tadamasa Teranishi
 */

#ifndef TOGL_IMG_HEADER
#define	TOGL_IMG_HEADER

#include <stdio.h>
#include <stdlib.h>

#ifdef	WIN32
# include <windows.h>

#pragma warning(disable : 4244)     // MIPS
#pragma warning(disable : 4136)     // X86
#pragma warning(disable : 4051)     // ALPHA
#endif	/* WIN32 */

#include <GL/gl.h>
#include <GL/glu.h>

#define TOGL_VERSION_IMAGE		"1.01"

typedef struct {
	unsigned char	*m_buffer;
	int		m_width, m_height;
	int		m_components;
	int		dummy[16];
} TOGLimage;


#ifdef WIN32
#	ifdef DLLEXPORT
#		define	DLL   __declspec( dllexport )
#	endif
#	ifdef DLLIMPORT
#		define	DLL   __declspec( dllimport )
#	endif
#endif

#ifndef DLL
#define DLL
#endif

#ifdef __cplusplus	/*	defined __cplusplus	*/
extern "C" {
#endif

DLL void toglInitImage(TOGLimage *img);
DLL GLboolean toglAllocImage(TOGLimage *img);
DLL void toglDeleteImage(TOGLimage *img);

#ifdef __cplusplus	/*	defined __cplusplus	*/
}
#endif

#include "toglimgbmp.h"
#include "toglimgjpeg.h"
#include "toglimgpng.h"

#include "toglimgbump.h"

#ifdef __cplusplus	/*	defined __cplusplus	*/
extern "C" {
#endif

DLL GLboolean toglReadImage(char filename[], TOGLimage *img);
DLL GLboolean toglWriteImage(char filename[], TOGLimage *img);

#ifdef __cplusplus	/*	defined __cplusplus	*/
}
#endif


#endif	/* TOGL_IMG_HEADER */
